/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 31.10.2014
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <string.h>

// Standard Input/Output functions
#include <stdio.h>
#define KEY !PINB.4
#define LED_RED PORTB.5
#define DOOR PORTB.2
#define BUZER PORTD.4

#define testbit(var,_bit) ((var >> _bit) & 1)     //
#define GETBIT(x,n) ((x)&1L<<(n))
//unsigned char a1,a2,a3,a4,a5,a6,a7,a8,a9,a10;
unsigned char RFID_Buffer [6];  // RFID
unsigned int num;
unsigned char RFID_Code [6];  // 
unsigned char RFID_Comp []= {0x00,0x00,0xFD,0xC2,0x3F};

    
unsigned char crc;//,crc2;
//unsigned char Timer = 0;        //   
unsigned char data, RFIDBitCount, RFIDBufferPtr, Header, Time, RFIDFound, Rising, Direction, crc_count;

unsigned char CheckCRC(unsigned char *buffer)
{
        unsigned char i;
        crc = 0;
        for (i=0; i<5; i++){
                crc = crc ^ ( buffer[i] & 0x0F ) ^ ( ( buffer[i] >> 4 ) & 0x0F );    
        }
        if (crc != ( buffer[5] & 0x0F )) { return 0; } else { return 1; } 
}

// Timer1 input capture interrupt service routine
interrupt [TIM1_CAPT] void timer1_capt_isr(void)
{
//LED_RED=1;
        if(RFIDFound)return;
        Time = ICR1L;
        TCNT1L = 0;
        TCNT1H = 0;
        TIFR |= 0x20; 
        if ( Time < 7 ) { return; }
        if ( Time > 30 ) { return; }
        if ( TCCR1B == 0x84 ) { TCCR1B = 0xC4; Rising = 0;} else { TCCR1B = 0x84; Rising = 1; } //        (-) 
        if (data) {
                if ( Direction ) { //   - 
                        if (!Rising) { //    -   
                                if ((++crc_count == 5)&( RFIDBitCount < 40 )) {
                                        crc_count = 0;
                                        if (crc == 1 ) { data = 0;}  //    
                                        crc = 0;  
                                } else {  
                                        RFID_Buffer[RFIDBufferPtr] <<= 1; //  
                                        if ((++RFIDBitCount & 7) == 0) RFIDBufferPtr++; //   
                                        if (crc_count == 0) { crc = 0; } else { crc ^= 0; } //    
                                } 
                        }                                                
                } else {
                        if (Rising) { //    -   
                                if ((++crc_count == 5)&( RFIDBitCount < 40 )) {
                                        crc_count = 0;
                                        if (crc == 0) { data = 0;}  //    
                                        crc = 0;  
                                } else {  
                                        RFID_Buffer[RFIDBufferPtr] <<= 1; //  
                                        RFID_Buffer[RFIDBufferPtr] += 0x01;
                                        if ((++RFIDBitCount & 7) == 0) RFIDBufferPtr++; //   
                                        if (crc_count == 0) { crc = 1; } else { crc ^= 1; } //     
                                }
                        }                                                
                }
                if (RFIDBitCount == 45) {RFIDFound = 1; data = 0; RFIDBitCount = 0; return; } 
                if (( Time >= 16 )&(Time <= 20 )) { 
                        Direction = !Direction; //      -        
                }
        } else {   
                if (( Time >= 16 )&( Time <= 20 )&(Rising)) {  
                        if ( Header > 10 ) 
                        { 
                                data = 1;
                                Direction = 1;
                                RFIDBitCount = 0; RFIDBufferPtr = 0; crc_count = 0; Header = 0;
                                RFID_Buffer[0]=0; RFID_Buffer[1]=0; RFID_Buffer[2]=0; RFID_Buffer[3]=0; RFID_Buffer[4]=0; RFID_Buffer[5]=0;
                                
                        } 
                } else {
                        if (( Time >= 8 )&( Time <= 10 )) { Header++; 
                        } else { Header = 0; }
                }
        }         
//LED_RED=0;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=T State0=T 
PORTB=0x00;
DDRB=0x2C;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=0 State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x10;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
TCCR0=0x03;
TCNT0=0x10;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: On
// Input Capture on Rising Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: On
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0xC4;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x12;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: CTC top=OCR2
// OC2 output: Toggle on compare match
ASSR=0x00;
TCCR2=0x19;
TCNT2=0x00;
OCR2=32;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x20;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 38400
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x0C;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
 {
      // Place your code here   
      char z,c;
      //if(KEY){OCR2--;delay_ms(250);}
     // LED_RED=1;delay_ms(250);LED_RED=0;delay_ms(250); 
          if (RFIDFound) {
        LED_RED=1;
        
        
        memcpy(RFID_Code,RFID_Buffer,6);
        
        
        if ( CheckCRC(RFID_Code) ) { 
                num = (unsigned int)(RFID_Code[3] << 8)|RFID_Code[4];
                printf("RFID found.\n\r");
                printf("ID Card: %02X%02X%02X%02X%02X Number: %u.%u\n\r",RFID_Code[0],RFID_Code[1],RFID_Code[2],RFID_Code[3],RFID_Code[4],RFID_Code[2], num);
        }
    
    c=0;
    for (z=0;z<5;z++) {
    if(RFID_Code[z]==RFID_Comp[z]) c++;
                      };
    if(c==5){
             printf("DOOR!!!");
             DOOR=1; 
             for (z=0;z<8;z++) {
             BUZER=1;
             delay_ms(150);
             BUZER=0;
             delay_ms(150);
             };
             DOOR=0;
             }
        
            else {
            BUZER=1;
            delay_ms(500);
            BUZER=0;
            }
    
    LED_RED=0;
    RFIDFound = 0;
    }                                                                                                            
 }
}
